"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = exports.CONFIGURED_INTEGRATIONS = exports.VERSION = void 0;
const common_1 = require("@nestjs/common");
const config_1 = __importDefault(require("config"));
const integrations_module_1 = require("./integrations/integrations.module");
const entities_module_1 = require("./entities/entities.module");
const config_module_1 = require("./config/config.module");
const cluster_module_1 = require("./cluster/cluster.module");
const schedule_1 = require("@nestjs/schedule");
const lodash_1 = __importDefault(require("lodash"));
const nest_emitter_1 = require("nest-emitter");
const events_1 = require("events");
const logger_1 = require("./logger");
const status_module_1 = require("./status/status.module");
const nestjs_prometheus_1 = require("@willsoto/nestjs-prometheus");
const prom_client_1 = require("prom-client");
const events_module_1 = require("./events/events.module");
exports.VERSION = require('../package.json').version;
exports.CONFIGURED_INTEGRATIONS = config_1.default
    .get('global.integrations')
    .map((id) => lodash_1.default.kebabCase(id).replace(/-([1-9]+)-/, '$1'));
prom_client_1.register.setDefaultLabels({
    instanceName: config_1.default.get('global.instanceName'),
});
let AppModule = class AppModule {
};
AppModule = __decorate([
    (0, common_1.Module)({
        imports: [
            events_module_1.EventsModule,
            entities_module_1.EntitiesModule,
            config_module_1.ConfigModule,
            cluster_module_1.ClusterModule,
            status_module_1.StatusModule,
            schedule_1.ScheduleModule.forRoot(),
            nest_emitter_1.NestEmitterModule.forRoot(new events_1.EventEmitter()),
            nestjs_prometheus_1.PrometheusModule.register(),
            integrations_module_1.IntegrationsModule.register(exports.CONFIGURED_INTEGRATIONS, logger_1.WINSTON_LOGGER),
        ],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map