"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var ConfigService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigService = void 0;
const common_1 = require("@nestjs/common");
const config_1 = __importDefault(require("config"));
const app_config_1 = require("../app.config");
const path_1 = require("path");
const jf = __importStar(require("joiful"));
let ConfigService = ConfigService_1 = class ConfigService {
    constructor() {
        this.logger = new common_1.Logger(ConfigService_1.name);
    }
    onModuleInit() {
        const sources = config_1.default.util.getConfigSources().map((source) => source.name);
        this.logger.log(`Loading configuration from ${sources.join(', ')} (Current: ${process.cwd()})`);
        if (sources.length == 1) {
            const folders = process.env.NODE_CONFIG_DIR.split(path_1.delimiter).map((folder) => folder.startsWith('.') ? folder.replace('.', process.cwd()) : folder);
            folders.shift();
            this.logger.warn(`No configuration found in ${folders.join(', ')}`);
        }
        this.validateConfig(config_1.default);
    }
    validateConfig(cfg) {
        var _a;
        const results = jf.validateAsClass(cfg, app_config_1.AppConfig, {
            abortEarly: false,
            convert: false,
        });
        (_a = results === null || results === void 0 ? void 0 : results.error) === null || _a === void 0 ? void 0 : _a.details.forEach((detail) => {
            var _a, _b;
            let msg = `${detail.message} [Value: ${JSON.stringify((_a = detail === null || detail === void 0 ? void 0 : detail.context) === null || _a === void 0 ? void 0 : _a.value)}].`;
            msg += ((_b = detail === null || detail === void 0 ? void 0 : detail.context) === null || _b === void 0 ? void 0 : _b.message)
                ? ` Additional Context: ${JSON.stringify(detail.context.message)}`
                : '';
            this.logger.error(msg);
        });
    }
    get(setting) {
        return config_1.default.get(setting);
    }
};
ConfigService = ConfigService_1 = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [])
], ConfigService);
exports.ConfigService = ConfigService;
//# sourceMappingURL=config.service.js.map