"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerConfig = void 0;
const jf = __importStar(require("joiful"));
class IdKeyPair {
}
__decorate([
    (jf.string().required()),
    __metadata("design:type", String)
], IdKeyPair.prototype, "id", void 0);
__decorate([
    (jf.string().required()),
    __metadata("design:type", String)
], IdKeyPair.prototype, "api_key", void 0);
class ApiKeyAuthConfig {
}
__decorate([
    (jf.any().custom(validateApiKey).required()),
    __metadata("design:type", Object)
], ApiKeyAuthConfig.prototype, "apiKey", void 0);
class BasicAuthConfig {
}
__decorate([
    (jf.string().required()),
    __metadata("design:type", String)
], BasicAuthConfig.prototype, "username", void 0);
__decorate([
    (jf.string().required()),
    __metadata("design:type", String)
], BasicAuthConfig.prototype, "password", void 0);
class ElasticsearchConfig {
    constructor() {
        this.enabled = false;
        this.node = 'http://localhost:9200';
        this.indexPrefix = 'room-assistant';
    }
}
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], ElasticsearchConfig.prototype, "enabled", void 0);
__decorate([
    (jf.string().required()),
    __metadata("design:type", Object)
], ElasticsearchConfig.prototype, "node", void 0);
__decorate([
    (jf.any().custom(validateAuthType).optional()),
    __metadata("design:type", Object)
], ElasticsearchConfig.prototype, "auth", void 0);
__decorate([
    (jf.string().required()),
    __metadata("design:type", Object)
], ElasticsearchConfig.prototype, "indexPrefix", void 0);
class LokiConfig {
    constructor() {
        this.enabled = false;
        this.host = 'http://localhost:3100';
    }
}
__decorate([
    (jf.boolean().required()),
    __metadata("design:type", Object)
], LokiConfig.prototype, "enabled", void 0);
__decorate([
    (jf
        .string()
        .uri({ scheme: ['http', 'https'] })
        .required()),
    __metadata("design:type", Object)
], LokiConfig.prototype, "host", void 0);
class LoggerConfig {
    constructor() {
        this.elasticsearch = new ElasticsearchConfig();
        this.loki = new LokiConfig();
    }
}
__decorate([
    (jf.object({ objectClass: ElasticsearchConfig }).required()),
    __metadata("design:type", Object)
], LoggerConfig.prototype, "elasticsearch", void 0);
__decorate([
    (jf.object({ objectClass: LokiConfig }).required()),
    __metadata("design:type", Object)
], LoggerConfig.prototype, "loki", void 0);
exports.LoggerConfig = LoggerConfig;
function validateAuthType(options) {
    return options.joi
        .alternatives()
        .try(jf.getSchema(BasicAuthConfig), jf.getSchema(ApiKeyAuthConfig));
}
function validateApiKey(options) {
    return options.joi
        .alternatives()
        .try(options.joi.string(), jf.getSchema(IdKeyPair));
}
//# sourceMappingURL=logger.config.js.map