"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebounceProxyHandler = void 0;
const lodash_1 = __importDefault(require("lodash"));
class DebounceProxyHandler {
    constructor(config) {
        var _a, _b;
        this.debouncedStateUpdate = lodash_1.default.debounce((target, value) => {
            target.state = value;
        }, config.wait * 1000, {
            maxWait: config.maxWait * 1000,
            leading: (_a = config.leading) !== null && _a !== void 0 ? _a : false,
            trailing: (_b = config.trailing) !== null && _b !== void 0 ? _b : true,
        });
    }
    set(target, p, value) {
        const oldValue = target[p];
        if (p === 'state' && oldValue !== value) {
            this.debouncedStateUpdate(target, value);
        }
        else {
            target[p] = value;
        }
        return true;
    }
}
exports.DebounceProxyHandler = DebounceProxyHandler;
//# sourceMappingURL=debounce.proxy.js.map