import { Entity } from './entity.dto';
import { EntitiesEventEmitter } from './entities.events';
import { EntityCustomization } from './entity-customization.interface';
import { ClusterService } from '../cluster/cluster.service';
import { ConfigService } from '../config/config.service';
export declare class EntitiesService {
    private readonly clusterService;
    private readonly configService;
    private readonly emitter;
    private readonly config;
    private readonly entities;
    private readonly logger;
    constructor(clusterService: ClusterService, configService: ConfigService, emitter: EntitiesEventEmitter);
    has(id: string): boolean;
    get(id: string): Entity;
    getAll(): Entity[];
    add(entity: Entity, customizations?: Array<EntityCustomization<any>>): Entity;
    hasAuthorityOver(entity: Entity): boolean;
    private applyEntityBehaviors;
}
