import { OnGatewayDisconnect } from '@nestjs/websockets';
import WebSocket from 'ws';
import { EntitiesEventEmitter } from '../entities/entities.events';
import { OnModuleInit } from '@nestjs/common';
declare type SubscriptionType = 'entityUpdates';
interface SubscriptionRequest {
    type: SubscriptionType;
}
interface SubscriptionResult {
    type: SubscriptionType;
    success: boolean;
    details?: string;
}
export declare class EventsGateway implements OnModuleInit, OnGatewayDisconnect {
    private readonly emitter;
    private readonly subscribedSockets;
    constructor(emitter: EntitiesEventEmitter);
    onModuleInit(): void;
    handleDisconnect(client: WebSocket): void;
    handleSubscriptionEvent(client: WebSocket, data: SubscriptionRequest): SubscriptionResult;
    private handleEntityUpdate;
}
export {};
