"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventsGateway = void 0;
const websockets_1 = require("@nestjs/websockets");
const ws_1 = __importDefault(require("ws"));
const nest_emitter_1 = require("nest-emitter");
let EventsGateway = class EventsGateway {
    constructor(emitter) {
        this.emitter = emitter;
        this.subscribedSockets = new Set();
    }
    onModuleInit() {
        this.emitter.on('entityUpdate', this.handleEntityUpdate.bind(this));
    }
    handleDisconnect(client) {
        this.subscribedSockets.delete(client);
    }
    handleSubscriptionEvent(client, data) {
        if (data.type !== 'entityUpdates') {
            return {
                type: data.type,
                success: false,
                details: 'Requested subscription type is not supported',
            };
        }
        this.subscribedSockets.add(client);
        return {
            type: data.type,
            success: true,
        };
    }
    handleEntityUpdate(entity, diff, hasAuthority) {
        const update = {
            entity,
            diff,
            hasAuthority,
        };
        const updateMsg = JSON.stringify(update);
        this.subscribedSockets.forEach((socket) => {
            socket.send(updateMsg);
        });
    }
};
__decorate([
    (0, websockets_1.SubscribeMessage)('subscribeEvents'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ws_1.default, Object]),
    __metadata("design:returntype", Object)
], EventsGateway.prototype, "handleSubscriptionEvent", null);
EventsGateway = __decorate([
    (0, websockets_1.WebSocketGateway)(),
    __param(0, (0, nest_emitter_1.InjectEventEmitter)()),
    __metadata("design:paramtypes", [Object])
], EventsGateway);
exports.EventsGateway = EventsGateway;
//# sourceMappingURL=events.gateway.js.map