"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BluetoothHealthIndicator = void 0;
const terminus_1 = require("@nestjs/terminus");
const common_1 = require("@nestjs/common");
const health_indicator_service_1 = require("../../status/health-indicator.service");
const bluetooth_service_1 = require("./bluetooth.service");
let BluetoothHealthIndicator = class BluetoothHealthIndicator extends terminus_1.HealthIndicator {
    constructor(bluetoothService, healthIndicatorService) {
        super();
        this.bluetoothService = bluetoothService;
        healthIndicatorService === null || healthIndicatorService === void 0 ? void 0 : healthIndicatorService.registerHealthIndicator(async () => this.lowEnergyAdvertisementTimeoutCheck(2 * 60 * 1000));
        healthIndicatorService === null || healthIndicatorService === void 0 ? void 0 : healthIndicatorService.registerHealthIndicator(async () => this.successiveErrorCheck(3));
    }
    lowEnergyAdvertisementTimeoutCheck(threshold) {
        const isHealthy = this.bluetoothService.timeSinceLastDiscovery < threshold;
        const result = this.getStatus('ble_advertisement_timeout', isHealthy);
        if (isHealthy) {
            return result;
        }
        throw new terminus_1.HealthCheckError(`No BLE advertisements recorded in over ${threshold}ms`, result);
    }
    successiveErrorCheck(threshold) {
        const isHealthy = this.bluetoothService.successiveErrorsOccurred < threshold;
        const result = this.getStatus(`bt_successive_errors`, isHealthy);
        if (isHealthy) {
            return result;
        }
        throw new terminus_1.HealthCheckError('BT Classic successive error check failed', result);
    }
};
BluetoothHealthIndicator = __decorate([
    (0, common_1.Injectable)(),
    __param(1, (0, common_1.Optional)()),
    __metadata("design:paramtypes", [bluetooth_service_1.BluetoothService,
        health_indicator_service_1.HealthIndicatorService])
], BluetoothHealthIndicator);
exports.BluetoothHealthIndicator = BluetoothHealthIndicator;
//# sourceMappingURL=bluetooth.health.js.map