"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Cluster = void 0;
class Cluster {
    constructor(pixels) {
        this.pixels = pixels;
    }
    get center() {
        return this.pixels.reduce((p, c) => c.temperature > p.temperature ? c : p);
    }
    isNeighboredTo(pixel) {
        return (this.pixels.find((value) => {
            return (value.x >= pixel.x - 1 &&
                value.x <= pixel.x + 1 &&
                value.y >= pixel.y - 1 &&
                value.y <= pixel.y + 1);
        }) !== undefined);
    }
}
exports.Cluster = Cluster;
//# sourceMappingURL=cluster.js.map