/// <reference types="typings/kalmanjs" />
import { OnApplicationBootstrap, OnModuleInit } from '@nestjs/common';
import { ConfigService } from '../../config/config.service';
import { EntitiesService } from '../../entities/entities.service';
import { ClusterService } from '../../cluster/cluster.service';
import { Node } from 'democracy';
import { NewRssiEvent } from './new-rssi.event';
import { SchedulerRegistry } from '@nestjs/schedule';
import { RoomPresenceDistanceSensor } from '../../integration-support/room-presence/room-presence-distance.sensor';
import { Device } from './device';
import { Device as DeviceInfo } from '../home-assistant/device';
import { Switch } from '../../entities/switch';
import { DeviceTracker } from '../../entities/device-tracker';
import { BluetoothService } from '../../integration-support/bluetooth/bluetooth.service';
declare const BluetoothClassicService_base: {
    new (...args: any[]): {
        kalmanFilterMap: Map<string, import("kalmanjs").default>;
        kalmanFilter(value: number, id?: string): number;
    };
} & ObjectConstructor;
export declare class BluetoothClassicService extends BluetoothClassicService_base implements OnModuleInit, OnApplicationBootstrap {
    private readonly bluetoothService;
    private readonly configService;
    private readonly entitiesService;
    private readonly clusterService;
    private readonly schedulerRegistry;
    private readonly config;
    private rotationOffset;
    private inquiriesSwitch;
    private deviceMap;
    private logger;
    constructor(bluetoothService: BluetoothService, configService: ConfigService, entitiesService: EntitiesService, clusterService: ClusterService, schedulerRegistry: SchedulerRegistry);
    onModuleInit(): Promise<void>;
    onApplicationBootstrap(): void;
    handleRssiRequest(address: string): Promise<void>;
    handleNewRssi(event: NewRssiEvent): Promise<void>;
    distributeInquiries(): void;
    filterRssi(address: string, rssi: number): number;
    updateSensorState(sensor: RoomPresenceDistanceSensor, device: Device): void;
    getParticipatingNodes(): Node[];
    shouldInquire(): boolean;
    protected createInquiriesSwitch(): Switch;
    protected createSensor(sensorId: string, device: Device): Promise<RoomPresenceDistanceSensor>;
    protected createDeviceTracker(id: string, name: string, deviceInfo: DeviceInfo): DeviceTracker;
    protected calculateCurrentTimeout(): number;
    protected mapArrays(a1: any[], a2: any[], offset: number): [any[], any[]];
}
export {};
