/// <reference types="node" />
import { OnApplicationShutdown, OnModuleInit } from '@nestjs/common';
import { Entity } from '../../entities/entity.dto';
import { EntityConfig } from './entity-config';
import { ConfigService } from '../../config/config.service';
import { Device } from './device';
import { EntitiesEventEmitter, PropertyDiff } from '../../entities/entities.events';
import { EntityCustomization } from '../../entities/entity-customization.interface';
import { EntitiesService } from '../../entities/entities.service';
import { ClusterService } from '../../cluster/cluster.service';
export declare class HomeAssistantService implements OnModuleInit, OnApplicationShutdown {
    private readonly configService;
    private readonly entitiesService;
    private readonly clusterService;
    private readonly emitter;
    private config;
    private device;
    private entityConfigs;
    private debounceFunctions;
    private mqttClient?;
    private readonly statusTopic;
    private readonly logger;
    constructor(configService: ConfigService, entitiesService: EntitiesService, clusterService: ClusterService, emitter: EntitiesEventEmitter);
    onModuleInit(): Promise<void>;
    onApplicationShutdown(): Promise<void>;
    handleNewEntity(entity: Entity, customizations?: Array<EntityCustomization<any>>): void;
    handleEntityUpdate(entity: Entity, diff: Array<PropertyDiff>, hasAuthority: boolean): void;
    sendHeartbeats(): void;
    refreshEntities(): void;
    handleIncomingMessage(topic: string, message: Buffer): void;
    isConnected(): boolean;
    protected handleReconnect(): void;
    protected getDeviceInfo(): Promise<Device>;
    protected getCombinedId(entityId: string, distributed?: boolean): string;
    protected generateEntityConfig(combinedId: string, entity: Entity): EntityConfig;
    private updateDistributedAvailability;
    protected applyCustomizations(config: EntityConfig, customizations: Array<EntityCustomization<any>>): EntityConfig;
    protected formatMessage(message: object): object;
    private clearRetained;
    private sendEntityStatus;
    private sendInstanceStatus;
    private sendDiscoveryMessage;
    private sendNewState;
    private sendNewAttributes;
    private sendNewMqttRoomDistances;
    private deepMap;
}
