"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwitchConfig = void 0;
const entity_config_1 = require("./entity-config");
class SwitchConfig extends entity_config_1.EntityConfig {
    constructor(id, name, onCallback, offCallback) {
        super('switch', id, name);
        this.payloadOn = 'on';
        this.payloadOff = 'off';
        this.stateOn = 'true';
        this.stateOff = 'false';
        this.commandTopic = `room-assistant/${this.component}/${id}/command`;
        this.commandStore = {
            on: onCallback,
            off: offCallback,
        };
    }
}
exports.SwitchConfig = SwitchConfig;
//# sourceMappingURL=switch-config.js.map