"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sleep = exports.promiseWithTimeout = void 0;
function promiseWithTimeout(promise, timeoutMs) {
    let timeoutHandle;
    const timeoutPromise = new Promise((resolve, reject) => {
        timeoutHandle = setTimeout(() => reject(new Error('timed out')), timeoutMs);
    });
    return Promise.race([promise, timeoutPromise]).then((result) => {
        clearTimeout(timeoutHandle);
        return result;
    });
}
exports.promiseWithTimeout = promiseWithTimeout;
async function sleep(ms) {
    return new Promise((resolve) => {
        setTimeout(resolve, ms);
    });
}
exports.sleep = sleep;
//# sourceMappingURL=promises.js.map